#! /bin/sh 

# 30 January 2002

# This is the official template for pipetool regression test scripts.
# In addition to supporting the "SHORTTEST" option, this script also
# allows the user to run individual subtests from the command line.
# The script will accept a series of test identifiers, generally of
# the form "test1" "test2" ... which are to be run.


# reproject_aspect.t
# test script for reproject_aspect


# syntax:
# reproject_aspect.t [<testid> ... ]
 



######################################################################
# subroutine
# error_exit <message>
# Fatal error exit

error_exit()
{
  echo "$1" | tee -a $LOGFILE
  echo "${toolname} : FAIL" | tee -a $LOGFILE
  exit 1
}

######################################################################
# subroutine
# keyfilter infile outfile
# filters out CHECKSUM, Dataset, CREATOR, HISTORY, DATASUM, 
#             ASCDSVER, HISTNUM, and DATE
# To filter additional keywords, add s/KEYWORD/Dataset/g; for each.

keyfilter()
{
  cat $1 | sed -e 's/CHECKSUM/Dataset/g;s/COMMENT/Dataset/g;
  s/DATE/Dataset/g;s/CREATOR/Dataset/g;s/HISTORY/Dataset/g;
  s/DATASUM/Dataset/g;s/ASCDSVER/Dataset/g;s/HISTNUM/Dataset/g' | \
  grep -v Dataset > $2
  zerotest $2
}

######################################################################
# subroutine
# find_tool <toolname>
# checks that tool exists and is runnable

find_tool()
{
  s1=`type $1`
  s2=`echo $s1 | awk -F" " '{ print $3}'`
  if test -x $s2 ; then
    :
  else
    error_exit "tool $1 not found"
  fi
}

######################################################################
# subroutine
# zerotest <file> 
# Makes sure that file is not 0 length.
# Use this to protect yourself against empty files  (which will 
# 'diff' without error).  This can happen when the input file to
# cat $infile | do_something >> $outfile
# is missing.  This is used by keyfilter(), above.

zerotest()
{
 if test -s $1 ;
 then
   :
 else
   echo "ERROR: file $1 is of zero length" >> $LOGFILE
   #  Indicate failure, but do not exit.
   mismatch=0
 fi
}


######################################################################
# Initialization

toolname="reproject_aspect"

# set up list of tests
alltests="test2 test3 test4 test5 test6 test7"

# "short" test to run
shortlist="test2"

# compute date string for log file
DT=`date +'%d%b%Y_%T'`

# check for directory environment variables
if test "x${TESTIN}" = "x" -o "x${TESTOUT}" = "x" -o "x${TESTSAV}" = "x" \
   -o "x${TESTLOG}" = "x" ; then
  error_exit "one or more of TESTIN/TESTOUT/TESTSAV/TESTLOG not defined" 
fi



# convenience definitions
OUTDIR=$TESTOUT/$toolname
SAVDIR=$TESTSAV/$toolname
INDIR=$TESTIN/$toolname
LOGDIR=$TESTLOG/$toolname

# set up log file name
LOGFILE=$LOGDIR/${toolname}_log.$DT

#get rid of old logs
rm -f $LOGDIR/${toolname}_log.*



# Any tests specified on command line?
if test $# -gt 0; then
  # yes, do those tests
  testlist=$*
else
  # No, see if we are to do "short" test
  if test "x$SHORTTEST" = "x" ; then
    # No, do everything
    testlist=$alltests
  else
    # yes, do short test
    testlist=$shortlist
  fi
fi


# Make sure we have a log directory
if test -d $LOGDIR ; then
 :
else
  mkdir -p $LOGDIR 
  if test $? -ne 0 ; then
    error_exit ""
  fi
fi


# Make sure we have an output directory
if test -d $OUTDIR ; then
 :
else
  mkdir -p $OUTDIR >> $LOGFILE 2>&1
  if test $? -ne 0 ; then
    error_exit "can't create output directory $OUTDIR"
  fi
fi

# check for tools
# if a utility is used in the form "utility <args> > outfile", and 'utility'
# cannot be run, 'outfile' will still be created.  If utility is used on 
# both the output and reference files of a tool the resultant utility output 
# files will both exist and be empty, and will pass a diff.

find_tool dmlist
find_tool dmimgcalc



# announce ourselves
echo ""
echo "${toolname} regression" | tee $LOGFILE
echo ""

# All parameters except verbose should be set anyway, but clear them
# to be safe.
bose=`pget $toolname verbose`
punlearn $toolname
pset $toolname verbose=$bose

script_succeeded=0

######################################################################
# Begin per-test loop

for testid in $testlist
do

  # delete old outputs
  rm -f $OUTDIR/${testid}*

  # Set up file names
  wcsupdinfile=$INDIR/${testid}_wcsupdfile.fits
  wcsupdoutfile=$OUTDIR/${testid}_wcsupdfile.fits
  wcsupdsavfile=$SAVDIR/${testid}_wcsupdfile.fits

  echo "" | tee -a $LOGFILE
  echo "running $testid" | tee -a $LOGFILE
  echo "" | tee -a $LOGFILE
  ####################################################################
  # run the tool
  case ${testid} in

    test2 ) # CDFN, obsids 2386 & 3388 test with wavdetect srcs
	    #  - absolute residual value test
            #  - fits image file wcs update
	    #...Define input files, params 
            infile1=$INDIR/${testid}_infile1.fits
            infile2=$INDIR/${testid}_infile2.fits
            refimgfile=$INDIR/${testid}_refImg.fits
	    test1_string="reproject_aspect \
	     refsrcfile=$infile1 infile=$infile2 \
	     wcsfile=$refimgfile updfile=$wcsupdoutfile \
	     outfile=\"\" \
	     radius=2 residlim=1 residfac=0 residtype=0"
            #...copy wcsupdate file into outdir
	    \cp -f $wcsupdinfile $wcsupdoutfile
	    #...run test
	    echo $test1_string | tee -a  $LOGFILE 
	    eval $test1_string  | tee -a  $LOGFILE  2>&1
            ;;
    test3 ) # CDFN, obsids 2386 & 3388 test with wavdetect srcs
	    #  - residual-to-position error ratio test
            #  - asol file update test
	    #...Define input files, params 
            infile1=$INDIR/${testid}_infile1.fits
            infile2=$INDIR/${testid}_infile2.fits
            refimgfile=$INDIR/${testid}_refImg.fits
            asolinfile=$INDIR/${testid}_asol.fits
            asoloutfile=$OUTDIR/${testid}_asolout.fits
            asolsavfile=$SAVDIR/${testid}_asolout.fits
	    test_string="reproject_aspect \
	     refsrcfile=$infile1 infile=$infile2 \
             wcsfile=$refimgfile updfile=$asolinfile \
	     outfile=$asoloutfile \
	     radius=2 residlim=0.0 residfac=0.755 residtype=1"
	    #...run test
	    echo $test_string | tee -a  $LOGFILE 
	    eval $test_string  | tee -a  $LOGFILE  2>&1
            ;;
    test4 ) # CDFN, obsids 2386 & 3388 test with wavdetect srcs
	    #  - absolute residual value test
            #  - fits image file wcs update
	    #...Define input files, params 
            infile1=$INDIR/test2_infile1.fits
            infile2=$INDIR/test2_infile2.fits
            refimgfile=$INDIR/test2_refImg.fits
	    test_string="reproject_aspect \
	     refsrcfile=$infile1 infile=$infile2 \
	     wcsfile=$refimgfile updfile=$wcsupdoutfile \
	     outfile=\"\" method=rst \
	     radius=2 residlim=1 residfac=0 residtype=0"
            #...copy wcsupdate file into outdir
	    \cp -f $INDIR/test2_wcsupdfile.fits $wcsupdoutfile
	    #...run test
	    echo $test_string | tee -a  $LOGFILE 
	    eval $test_string  | tee -a  $LOGFILE  2>&1
            ;;

    test5 ) # CDFN, obsids 2386 & 3388 test with wavdetect srcs
	    #  - absolute residual value test
            #  - fits image file wcs update
	    #...Define input files, params 
            infile1=$INDIR/test2_infile1.fits
            infile2=$INDIR/test2_infile2.fits
            refimgfile=$INDIR/test2_refImg.fits
	    test_string="reproject_aspect \
	     refsrcfile=$infile1 infile=$infile2 \
	     wcsfile=$refimgfile updfile=$wcsupdoutfile \
	     outfile=\"\" method=trans\
	     radius=2 residlim=1 residfac=0 residtype=0"
            #...copy wcsupdate file into outdir
	    \cp -f $INDIR/test2_wcsupdfile.fits $wcsupdoutfile
	    #...run test
	    echo $test_string | tee -a  $LOGFILE 
	    eval $test_string  | tee -a  $LOGFILE  2>&1
            ;;
    test6 ) # CDFN, obsids 2386 & 3388 test with wavdetect srcs
	    #  - residual-to-position error ratio test
            #  - asol file update test
	    #...Define input files, params 
            infile1=$INDIR/test3_infile1.fits
            infile2=$INDIR/test3_infile2.fits
            refimgfile=$INDIR/test3_refImg.fits
            asolinfile=$INDIR/test3_asol.fits
            asoloutfile=$OUTDIR/${testid}_asolout.fits
            asolsavfile=$SAVDIR/${testid}_asolout.fits
	    test_string="reproject_aspect \
	     refsrcfile=$infile1 infile=$infile2 \
             wcsfile=$refimgfile updfile=$asolinfile \
	     outfile=$asoloutfile method=trans \
	     radius=2 residlim=0.0 residfac=0.755 residtype=1"
	    #...run test
	    echo $test_string | tee -a  $LOGFILE 
	    eval $test_string  | tee -a  $LOGFILE  2>&1
            ;;
    test7 ) # CDFN, obsids 2386 & 3388 test with wavdetect srcs
	    #  - residual-to-position error ratio test
            #  - asol file update test
	    #...Define input files, params 
            infile1=$INDIR/test3_infile1.fits
            infile2=$INDIR/test3_infile2.fits
            refimgfile=$INDIR/test3_refImg.fits
            asolinfile=$INDIR/test3_asol.fits
            asoloutfile=$OUTDIR/${testid}_asolout.fits
            asolsavfile=$SAVDIR/${testid}_asolout.fits
	    test_string="reproject_aspect \
	     refsrcfile=$infile1 infile=$infile2 \
             wcsfile=$refimgfile updfile=$asolinfile \
	     outfile=$asoloutfile method=rst \
	     radius=2 residlim=0.0 residfac=0.755 residtype=1"
	    #...run test
	    echo $test_string | tee -a  $LOGFILE 
	    eval $test_string  | tee -a  $LOGFILE  2>&1
            ;;

  esac

  ####################################################################
  # check the outputs

  # Init per-test error flag
  mismatch=1

  ####################################################################
  # FITS table

  # new output
  #dmlist $outfile opt=header,data,clean rows=700:1400 > \
  # $OUTDIR/${testid}.dmp1 2>>$LOGFILE
  #keyfilter $OUTDIR/${testid}.dmp1 $OUTDIR/${testid}.dmp2 \
  # 2>>$LOGFILE
  
  # reference output
  #dmlist $savfile opt=header,data,clean rows=700:1400 > \
  # $OUTDIR/${testid}.dmp1_std 2>>$LOGFILE
  #keyfilter $OUTDIR/${testid}.dmp1_std $OUTDIR/${testid}.dmp2_std \
  # 2>>$LOGFILE
  
  # compare
  #diff $OUTDIR/${testid}.dmp2 $OUTDIR/${testid}.dmp2_std > \
  # /dev/null 2>>$LOGFILE

  case ${testid} in
      test2) 
        dmdiff $wcsupdoutfile $wcsupdsavfile tol=$SAVDIR/tolerance > /dev/null 2>>$LOGFILE
	;;
      test3)
        dmdiff $asoloutfile $asolsavfile tol=$SAVDIR/tolerance > /dev/null 2>>$LOGFILE
	;;
      test4)
        dmdiff $wcsupdoutfile $wcsupdsavfile tol=$SAVDIR/tolerance > /dev/null 2>>$LOGFILE
	;;
      test5)
        dmdiff $wcsupdoutfile $wcsupdsavfile tol=$SAVDIR/tolerance > /dev/null 2>>$LOGFILE
	;;
      test6)
        dmdiff $asoloutfile $asolsavfile tol=$SAVDIR/tolerance > /dev/null 2>>$LOGFILE
	;;
      test7)
        dmdiff $asoloutfile $asolsavfile tol=$SAVDIR/tolerance > /dev/null 2>>$LOGFILE
	;;
  esac
  if  test $? -ne 0 ; then
    echo "ERROR: MISMATCH in $wcsupdoutfile" >> $LOGFILE
    mismatch=0
  fi
  
  ####################################################################
  # Did we get an error?
  if test $mismatch -eq 0 ; then
    # Yes
    echo "${testid} NOT-OK"
    script_succeeded=1
  else
    # No
    echo "${testid} OK"
  fi

done
# end per-test loop
######################################################################


######################################################################
# report results

# blank line
echo ""

if test $script_succeeded -eq 0; then
    echo "${toolname} : PASS" | tee -a $LOGFILE
else
    echo "${toolname} : FAIL" | tee -a $LOGFILE
fi

echo "log file in ${LOGFILE}"


exit $script_succeeded
